<?php
/**
* @version		$Id: index.php 10381 2008-06-01 03:35:53Z pasamio $
* @package		Joomla
* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// Set flag that this is a parent file
define( '_JEXEC', 1 );

define('JPATH_BASE', dirname(__FILE__).'/../..' );

define( 'DS', DIRECTORY_SEPARATOR );

require_once ( JPATH_BASE .DS.'includes'.DS.'defines.php' );
require_once ( JPATH_BASE .DS.'includes'.DS.'framework.php' );
require_once ( JPATH_BASE .DS.'libraries'.DS.'joomla'.DS.'html'.DS.'parameter.php' );
require_once ( JPATH_BASE .DS.'libraries'.DS.'joomla'.DS.'application'.DS.'module'.DS.'helper.php' );
require_once ( JPATH_BASE .DS.'libraries'.DS.'joomla'.DS.'user'.DS.'authentication.php' );
require_once ( JPATH_BASE .DS.'libraries'.DS.'joomla'.DS.'language'.DS.'language.php');

function mobio_checkcode($servID, $code, $debug=0) {

	$res_lines = file("http://www.mobio.bg/code/checkcode.php?servID=$servID&code=$code");

	$ret = 0;
	if($res_lines) {

		if(strstr("PAYBG=OK", $res_lines[0])) {
			$ret = 1;
		}else{
			if($debug)
				echo $line."\n";
		}
	}else{
		if($debug)
			echo "Unable to connect to mobio.bg server.\n";
		$ret = 0;
	}

	return $ret;
}

function mobio_checkcode_mservIDs($servIDs_str, $code, $debug=0) {

	if(strstr($servIDs_str, ',')) {
		$servIDs = explode(',', $servIDs_str);

		foreach($servIDs as $servID) {
			if(mobio_checkcode($servID, $code, $debug)) {
				return 1;
			}
		}
	}else{
		return mobio_checkcode($servIDs_str, $code);
	}
	
	return 0;
}




$mainframe =& JFactory::getApplication('site');
$mainframe->initialise();

$mh = new JModuleHelper();
$module = $mh->getModule('smslogin');
$params = new JParameter( $module->params );
$smslogin = $params->get('smslogin');
$servID = $params->get('servID');

$smscode = $_REQUEST["smscode"];


$params   = JComponentHelper::getParams('com_languages');
$frontend_lang = $params->get('site', 'en-GB');

$lang = new JLanguage();
$lang->load('mod_smslogin', JPATH_BASE, $frontend_lang);


if ($return = JRequest::getVar('return', '', 'method', 'base64')) {
	$return = base64_decode($return);
	if (!JURI::isInternal($return)) {
		//$return = '';  TODO: check
	}
}



switch($smslogin) {

	case 1:
		// default Joomla login + SMS code check	

		$credentials = array();
		$credentials['username'] = JRequest::getVar('username', '', 'method', 'username');
		$credentials['password'] = JRequest::getString('passwd', '', 'post', JREQUEST_ALLOWRAW);

		$options = array();
		$options['remember'] = JRequest::getBool('remember', false);
		$options['return'] = $return;
		$options['silent'] = 1;

		$authenticate = & JAuthentication::getInstance();
		$response         = $authenticate->authenticate($credentials, $options);

		if( $response->status === JAUTHENTICATE_STATUS_SUCCESS ) {
			if(mobio_checkcode_mservIDs($servID, $smscode)) {
				// mobio code is valid
				$mainframe->login($credentials, $options);
			}else{
				JError::raiseWarning('SOME_ERROR_CODE', $lang->_('INVALID_OR_EXPIRED_SMS_CODE'));
			}

		}else{
			JError::raiseWarning('SOME_ERROR_CODE', JText::_('E_LOGIN_AUTHENTICATE'));
		}

		$mainframe->redirect( $return );
	break;

	case 2:
		// SMS code check only

		if(mobio_checkcode_mservIDs($servID, $smscode)) {

			$credentials = array();
			$credentials['username'] = 'sms';
			$credentials['password'] = 'sms';

			$options = array();

			$error = $mainframe->login($credentials, $options);
		}else{
			JError::raiseWarning('SOME_ERROR_CODE', $lang->_('INVALID_OR_EXPIRED_SMS_CODE'));
		}
		$mainframe->redirect( $return );
	break;

	default:
		// default Joomla login

		$credentials = array();
		$credentials['username'] = JRequest::getVar('username', '', 'method', 'username');
		$credentials['password'] = JRequest::getString('passwd', '', 'post', JREQUEST_ALLOWRAW);

		$options = array();
		$options['remember'] = JRequest::getBool('remember', false);
		$options['return'] = $return;

		$error = $mainframe->login($credentials, $options);

		$mainframe->redirect( $return );
	break;
}
?>
